#
rm(list=ls())

#rpertoire
setwd("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/fact_analysis/multidimensional_scaling/tuto_madagascar")

#library
library(openxlsx)

#chargement
mcar <- openxlsx::read.xlsx("provinces_mcar.xlsx",sheet=1,colNames=T,rowNames=T)

#transf. en matrice de distance
dmcar <- as.dist(mcar)
print(dmcar)

#cmdscale
pmcar <- cmdscale(d=dmcar,k=2,eig=TRUE,x.ret=TRUE)
print(pmcar)

#qualit - uniquement v.p. positives
eig.pos <- pmcar$eig[pmcar$eig > 0]

#qualit relative
ceig.pos <- cumsum(eig.pos)/sum(eig.pos)
print(ceig.pos)

#graphique
plot(0:5,c(0,ceig.pos),type="b")

#graphique des points dans le plan
plot(pmcar$points[,1],pmcar$points[,2],type="p",cex=0.3,asp=1)
text(pmcar$points[,1],pmcar$points[,2],label=rownames(mcar))

#graphique "rarrang"
plot(pmcar$points[,2],-pmcar$points[,1],type="p",cex=0.3,asp=1)
text(pmcar$points[,2],-pmcar$points[,1],label=rownames(mcar))

#pour avoir uniquement des v.p. positifs
pmcar.bis <- cmdscale(d=dmcar,k=2,eig=TRUE,add=TRUE)
print(pmcar.bis)

#graphique avec correction
plot(pmcar.bis$points[,2],-pmcar.bis$points[,1],type="p",cex=0.3,asp=1)
text(pmcar.bis$points[,2],-pmcar.bis$points[,1],label=rownames(mcar))

#linariser la matrice de distance
d <- unclass(dmcar)
print(d)

#calcul des rangs des distances
rg <- rank(d)
print(rg)

#matrice des rangs
k <- 0
rmcar <- mcar
for (i in 1:(nrow(mcar)-1)){
  for (j in (i+1):ncol(mcar)){
    k <- k+1
    rmcar[i,j] <- rg[k]
    rmcar[j,i] <- rg[k]
  }
}
print(rmcar)

#classe dist
drmcar <- as.dist(rmcar)
print(drmcar)

#MASS
library(MASS)

#isoMDS - MDS non-mtrique
pmcar.iso <- isoMDS(drmcar,k=2)
print(pmcar.iso)

#graphique
plot(pmcar.iso$points[,2],-pmcar.iso$points[,1],type="p",cex=0.3,asp=1)
text(pmcar.iso$points[,2],-pmcar.iso$points[,1],label=rownames(mcar))
